﻿using System.ComponentModel.DataAnnotations;
using System.Data;

namespace OnlineMetodist.API.Models.Request.Account
{
    public class Registration
    {
        [Required]
        [Display(Name = "Email")]
        public string Email { get; set; }

        [Required]
        [Display(Name = "Фамилия")]
        public string Surname { get; set; }

        [Required]
        [Display(Name = "Имя")]
        public string Name { get; set; }

        [Display(Name = "Отчество")]
        public string? Patronymic { get; set; }


        [Required]
        [StringLength(20, MinimumLength = 4, ErrorMessage = "Длина пароля должна быть не менее 4 символов и не более 20")]
        [DataType(DataType.Password)]
        [Display(Name = "Пароль")]
        public string Password { get; set; }

        [Required]
        [StringLength(20, MinimumLength = 4, ErrorMessage = "Длина пароля должна быть не менее 4 символов и не более 20")]
        [Compare("Password", ErrorMessage = "Пароли не совпадают")]
        [DataType(DataType.Password)]
        [Display(Name = "Подтвердить пароль")]
        public string PasswordConfirm { get; set; }
    }
}
