﻿using OnlineMetodist.API.Services;
using System.ComponentModel.DataAnnotations;
using System.Text.Json.Serialization;

namespace OnlineMetodist.API.Models.Request.Events
{
    public class InternshipEvent
    {
        [Required]
        [DataType(DataType.Date)]
        [Display(Name = "Дата проведения")]
        [DisplayFormat(DataFormatString = "{yyyy-MM-dd}", ApplyFormatInEditMode = true)]
        [JsonConverter(typeof(DateOnlyJsonConverter))]
        public DateOnly DateOfEvent { get; set; }

        [Display(Name = "Последний день мероприятия")]
        [DataType(DataType.Date)]
        [DisplayFormat(DataFormatString = "{yyyy-MM-dd}", ApplyFormatInEditMode = true)]
        [JsonConverter(typeof(DateOnlyJsonConverter))]
        public DateOnly? EndDateOfEvent { get; set; }

        [Required]
        [Display(Name = "Место прохождения")]
        public string Location { get; set; }

        [Required]
        [Display(Name = "Количество часов")]
        public double QuantityOfHours { get; set; }

    }
}
