﻿using OnlineMetodist.API.Services;
using System.ComponentModel.DataAnnotations;
using System.Text.Json.Serialization;

namespace OnlineMetodist.API.Models.Request.Events
{
    public class ParticipationEvent
    {
        [Required]
        [DataType(DataType.Date)]
        [Display(Name = "Дата проведения")]
        [DisplayFormat(DataFormatString = "{yyyy-MM-dd}", ApplyFormatInEditMode = true)]
        [JsonConverter(typeof(DateOnlyJsonConverter))]
        public DateOnly DateOfEvent { get; set; }

        [Display(Name = "Последний день мероприятия")]
        [DataType(DataType.Date)]
        [DisplayFormat(DataFormatString = "{yyyy-MM-dd}", ApplyFormatInEditMode = true)]
        [JsonConverter(typeof(DateOnlyJsonConverter))]
        public DateOnly? EndDateOfEvent { get; set; }

        [Required]
        [Display(Name = "Название мероприятия")]
        public string Name { get; set; }

        [Required]
        [Display(Name = "Форма участия")]
        public string FormOfParticipation { get; set; }
        [Required]
        [Display(Name = "Форма мероприятия")]
        public string FormOfEvent { get; set; }

        [Required]
        [Display(Name = "Статус мероприятия")]
        public string Status { get; set; }

        [Required]
        [Display(Name = "Результат")]
        public string Result { get; set; }

    }
}
